import numpy as np

from escape.utils.widgets.base import PlotObjectLayout
from escape.utils.widgets.plot import Plot2dWidget

SLD0RE_TYPE = "sld0re"
SLD0IM_TYPE = "sld0im"


class MultilayerObjectLayout(PlotObjectLayout):
    
    plot2d_widget_class = Plot2dWidget
    
    def update(self, *args):
        tp = self.kwargs.get("yaxis", SLD0RE_TYPE)
        escobj = self.escobj
        pr = np.array(escobj.profile_sld0)
        lpr = len(pr)
        pr = pr.reshape((int(lpr / 3), 3))
        z = pr[:, 0]
        sld = []
        if tp == SLD0RE_TYPE:
            sld = pr[:, 1]
        elif tp == SLD0IM_TYPE:
            sld = pr[:, 2]
        else:
            raise ValueError("Unknown yaxis type {0}, expected {1}".format(
                tp, [SLD0RE_TYPE, SLD0IM_TYPE]))    
        self.center.update(z, sld)
        
